/*
 * Implementao de mutex locks e variveis de condio
 * utilizando semforos.
 */

#include <semaphore.h>

typedef struct {
  sem_t sem;
} mutex_t;

typedef void mutexattr_t;

int mutex_init(mutex_t *lock, mutexattr_t* attr);
int mutex_destroy(mutex_t *lock);
int mutex_lock(mutex_t *lock);
int mutex_unlock(mutex_t *lock);

/*------------------------------------------------------*/

typedef struct node_t {
  int n_wait;
  int n_signal;
  sem_t sem;
} node_t;
  
typedef struct {
  mutex_t lock;
  node_t *signal; /* Envio do signal ou broadcast */
  node_t *wait;   /* Entrada para espera */
} cond_t;

typedef void condattr_t;

int cond_init(cond_t *cond, condattr_t* attr);
int cond_destroy(cond_t *cond);
int cond_wait(cond_t *cond, 
              mutex_t *mutex_externo);
int cond_signal(cond_t *cond);
int cond_broadcast(cond_t *cond);
